Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## echopointng.model
Interface BoundedRangeModel

All Known Implementing Classes:
  DefaultBoundedRangeModel

    public interface BoundedRangeModel

Defines the data model used by components like ProgressBars and Sliders.

Defines four interrelated integer properties: minimum, maximum, extent and value. These four integers define two nested ranges like this:

>      minimum <= value <= value + extent <= maximum

The outer range is `minimum,maximum` and the inner range is `value,value+extent`. The inner range must lie within the outer one, i.e. `value` must be less than or equal to `maximum` and `value+extent` must greater than or equal to `minimum`, and `maximum` must be greater than or equal to `minimum`.

- The minimum and maximum set methods "correct" the other three properties to acommodate their new value argument. For example setting the model's minimum may change its maximum, value, and extent properties (in that order), to maintain the constraints specified above.
- The value and extent set methods "correct" their argument to fit within the limits defined by the other three properties. For example if `value == maximum`,`setExtent(10)` would change the extent (back) to zero.

Method Summary
`void` | `addChangeListener(ChangeListener cl)` Adds a ChangeListener to the model's listener list.
`int` | `getExtent()` Returns the model's extent, the length of the inner range that begins at the model's value.
`int` | `getMaximum()` Returns the model's maximum.
`int` | `getMinimum()` Returns the minimum acceptable value.
`int` | `getValue()` Returns the model's current value.
`boolean` | `getValueIsAdjusting()` Returns true if the current changes to the value property are part of a series of changes.
`void` | `removeChangeListener(ChangeListener cl)` Removes a ChangeListener from the model's listener list.
`void` | `setExtent(int newExtent)` Sets the model's extent.
`void` | `setMaximum(int newMaximum)` Sets the model's maximum to newMaximum .
`void` | `setMinimum(int newMinimum)` Sets the model's minimum to newMinimum .
`void` | `setRangeProperties(int value, int extent, int min, int max, boolean adjusting)` This method sets all of the model's data with a single method call.
`void` | `setValue(int newValue)` Sets the model's current value to `newValue` if `newValue` satisfies the model's constraints.
`void` | `setValueIsAdjusting(boolean b)` This attribute indicates that any upcoming changes to the value of the model should be considered a single event.

Method Detail

### addChangeListener

    void addChangeListener(ChangeListener cl)

  Adds a ChangeListener to the model's listener list.

  Parameters:
    `cl` - the ChangeListener to add

### getExtent

    int getExtent()

  Returns the model's extent, the length of the inner range that begins at the model's value.

  Returns:
    the value of the model's extent property

### getMaximum

    int getMaximum()

  Returns the model's maximum. Note that the upper limit on the model's value is (maximum - extent).

  Returns:
    the value of the maximum property.

### getMinimum

    int getMinimum()

  Returns the minimum acceptable value.

  Returns:
    the value of the minimum property

### getValue

    int getValue()

  Returns the model's current value. Note that the upper limit on the model's value is `maximum - extent` and the lower limit is `minimum`.

### getValueIsAdjusting

    boolean getValueIsAdjusting()

  Returns true if the current changes to the value property are part of a series of changes.

### removeChangeListener

    void removeChangeListener(ChangeListener cl)

  Removes a ChangeListener from the model's listener list.

### setExtent

    void setExtent(int newExtent)

  Sets the model's extent. The newExtent is forced to be greater than or equal to zero and less than or equal to maximum - value.

  When a BoundedRange model is used with a scrollbar the extent defines the length of the scrollbar knob (aka the "thumb" or "elevator"). The extent usually represents how much of the object being scrolled is visible. When used with a slider, the extent determines how much the value can "jump", for example when the user presses PgUp or PgDn.

  Notifies any listeners if the model changes.

### setMaximum

    void setMaximum(int newMaximum)

  Sets the model's maximum to newMaximum . The other three properties may be changed as well, to ensure that

  >      minimum <= value <= value + extent <= maximum

  Notifies any listeners if the model changes.

### setMinimum

    void setMinimum(int newMinimum)

  Sets the model's minimum to newMinimum . The other three properties may be changed as well, to ensure that:

  >      minimum <= value <= value + extent <= maximum

  Notifies any listeners if the model changes.

### setRangeProperties

    void setRangeProperties(int value,
                            int extent,
                            int min,
                            int max,
                            boolean adjusting)

  This method sets all of the model's data with a single method call. The method results in a single change event being generated. This is convenient when you need to adjust all the model data simulaneously and do not want individual change events to occur.

### setValue

    void setValue(int newValue)

  Sets the model's current value to `newValue` if `newValue` satisfies the model's constraints. Those constraints are:

  >      minimum <= value <= value + extent <= maximum

  Otherwise, if `newValue` is less than `minimum` it's set to `minimum`, if its greater than `maximum` then it's set to `maximum`, and if it's greater than `value+extent` then it's set to `value+extent`.

  When a BoundedRange model is used with a scrollbar the value specifies the origin of the scrollbar knob (aka the "thumb" or "elevator"). The value usually represents the origin of the visible part of the object being scrolled.

  Notifies any listeners if the model changes.

### setValueIsAdjusting

    void setValueIsAdjusting(boolean b)

  This attribute indicates that any upcoming changes to the value of the model should be considered a single event. This attribute will be set to true at the start of a series of changes to the value, and will be set to false when the value has finished changing. Normally this allows a listener to only take action when the final value change in committed, instead of having to do updates for all intermediate values.

  Parameters:
    `b` - true if the upcoming changes to the value property are part of a series

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD